Attribute VB_Name = "modStack"
Option Explicit

Private Const STACK_INCREMENT = 10
Private stack_inc_count As Long
Private stack_top As Long
Private stack_data() As Variant

Public Sub StackInit()
    Erase stack_data
'    If STACK_INCREMENT <= 0 Then
'        StackException (1)
'        Exit Sub
'    End If
    ReDim stack_data(STACK_INCREMENT)
    stack_top = 0
    stack_inc_count = 1
End Sub

Public Sub StackPush(vNewData As Variant)
    If (stack_top) = (stack_inc_count * STACK_INCREMENT) Then
        ReDim Preserve stack_data(stack_top + STACK_INCREMENT)
        stack_inc_count = (stack_inc_count + 1)
    End If
    stack_data(stack_top) = vNewData
    stack_top = (stack_top + 1)
End Sub

Public Function StackPop() As Variant
    If StackIsEmpty Then
        StackException (0)
        Exit Function
    End If

    If (stack_top) = ((stack_inc_count - 1) * STACK_INCREMENT) Then
        ReDim Preserve stack_data((stack_inc_count * STACK_INCREMENT) - STACK_INCREMENT)
        stack_inc_count = (stack_inc_count - 1)
    End If

    stack_top = (stack_top - 1)
    StackPop = stack_data(stack_top)
   ' StackIsEmpty
    
End Function

Public Function StackPeek() As Variant
    If stack_top = 0 Then
        StackException (0)
        Exit Function
    End If
    
    StackPeek = stack_data(stack_top - 1)
End Function

Public Function StackClear()
    ReDim stack_data(STACK_INCREMENT)
    stack_top = 0
    stack_inc_count = 1
End Function

Public Function StackCopy() As Variant()
    Dim i As Integer
    i = 0
    Do While i < stack_top
        StackCopy = stack_data
        i = (i + 1)
    Loop
End Function

Public Function StackCount() As Integer
    StackCount = stack_top
End Function

Private Sub StackException(iCode As Integer)
    Select Case iCode
        Case 0
           ' MsgBox " "
        Case 1
           ' MsgBox " "
    End Select
End Sub

Public Function StackIsEmpty() As Boolean
    If stack_top = 0 Then
        StackIsEmpty = True
    Else
        StackIsEmpty = False
    End If
End Function


